]> git.proxmox.com Git - mirror_ovs.git/blob - debian/openvswitch-ipsec.init
datapath: Cleanup netlink compat code.
[mirror_ovs.git] / debian / openvswitch-ipsec.init
1 #!/bin/sh
2 #
3 # Copyright (c) 2007, 2009 Javier Fernandez-Sanguino <jfs@debian.org>
4 #
5 # This is free software; you may redistribute it and/or modify
6 # it under the terms of the GNU General Public License as
7 # published by the Free Software Foundation; either version 2,
8 # or (at your option) any later version.
9 #
10 # This is distributed in the hope that it will be useful, but
11 # WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License with
16 # the Debian operating system, in /usr/share/common-licenses/GPL; if
17 # not, write to the Free Software Foundation, Inc., 59 Temple Place,
18 # Suite 330, Boston, MA 02111-1307 USA
19 #
20 ### BEGIN INIT INFO
21 # Provides: openvswitch-ipsec
22 # Required-Start: $network $local_fs $remote_fs openvswitch-switch
23 # Required-Stop: $remote_fs
24 # Default-Start: 2 3 4 5
25 # Default-Stop: 0 1 6
26 # Short-Description: Open vSwitch GRE-over-IPsec daemon
27 # Description: The ovs-monitor-ipsec script provides support for encrypting GRE
28 # tunnels with IPsec.
29 ### END INIT INFO
30
31 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
32
33 DAEMON=/usr/share/openvswitch/scripts/ovs-monitor-ipsec # Daemon's location
34 NAME=ovs-monitor-ipsec # Introduce the short server's name here
35 LOGDIR=/var/log/openvswitch # Log directory to use
36
37 PIDFILE=/var/run/openvswitch/$NAME.pid
38
39 test -x $DAEMON || exit 0
40
41 . /lib/lsb/init-functions
42
43 DODTIME=10 # Time to wait for the server to die, in seconds
44 # If this value is set too low you might not
45 # let some servers to die gracefully and
46 # 'restart' will not work
47
48 set -e
49
50 running_pid() {
51 # Check if a given process pid's cmdline matches a given name
52 pid=$1
53 name=$2
54 [ -z "$pid" ] && return 1
55 [ ! -d /proc/$pid ] && return 1
56 cmd=`cat /proc/$pid/cmdline | tr "\000" " "|cut -d " " -f 2`
57 # Is this the expected server
58 [ "$cmd" != "$name" ] && return 1
59 return 0
60 }
61
62 running() {
63 # Check if the process is running looking at /proc
64 # (works for all users)
65
66 # No pidfile, probably no daemon present
67 [ ! -f "$PIDFILE" ] && return 1
68 pid=`cat $PIDFILE`
69 running_pid $pid $DAEMON || return 1
70 return 0
71 }
72
73 start_server() {
74 if [ ! -d /var/run/openvswitch ]; then
75 install -d -m 755 -o root -g root /var/run/openvswitch
76 fi
77
78 /usr/share/openvswitch/scripts/ovs-monitor-ipsec \
79 --pidfile=$PIDFILE --log-file --detach --monitor \
80 unix:/var/run/openvswitch/db.sock
81
82 return 0
83 }
84
85 stop_server() {
86 if [ -e $PIDFILE ]; then
87 kill `cat $PIDFILE`
88 fi
89
90 return 0
91 }
92
93 force_stop() {
94 # Force the process to die killing it manually
95 [ ! -e "$PIDFILE" ] && return
96 if running ; then
97 kill -15 $pid
98 # Is it really dead?
99 sleep "$DODTIME"
100 if running ; then
101 kill -9 $pid
102 sleep "$DODTIME"
103 if running ; then
104 echo "Cannot kill $NAME (pid=$pid)!"
105 exit 1
106 fi
107 fi
108 fi
109 rm -f $PIDFILE
110 }
111
112
113 case "$1" in
114 start)
115 log_daemon_msg "Starting $NAME"
116 # Check if it's running first
117 if running ; then
118 log_progress_msg "apparently already running"
119 log_end_msg 0
120 exit 0
121 fi
122 if start_server && running ; then
123 # It's ok, the server started and is running
124 log_end_msg 0
125 else
126 # Either we could not start it or it is not running
127 # after we did
128 # NOTE: Some servers might die some time after they start,
129 # this code does not try to detect this and might give
130 # a false positive (use 'status' for that)
131 log_end_msg 1
132 fi
133 ;;
134 stop)
135 log_daemon_msg "Stopping $NAME"
136 if running ; then
137 # Only stop the server if we see it running
138 stop_server
139 log_end_msg $?
140 else
141 # If it's not running don't do anything
142 log_progress_msg "apparently not running"
143 log_end_msg 0
144 exit 0
145 fi
146 ;;
147 force-stop)
148 # First try to stop gracefully the program
149 $0 stop
150 if running; then
151 # If it's still running try to kill it more forcefully
152 log_daemon_msg "Stopping (force) $NAME"
153 force_stop
154 log_end_msg $?
155 fi
156 ;;
157 restart|force-reload)
158 log_daemon_msg "Restarting $NAME"
159 stop_server
160 # Wait some sensible amount, some server need this
161 [ -n "$DODTIME" ] && sleep $DODTIME
162 start_server
163 running
164 log_end_msg $?
165 ;;
166 status)
167 log_daemon_msg "Checking status of $NAME"
168 if running ; then
169 log_progress_msg "running"
170 log_end_msg 0
171 else
172 log_progress_msg "apparently not running"
173 log_end_msg 1
174 exit 1
175 fi
176 ;;
177 # Use this if the daemon cannot reload
178 reload)
179 log_warning_msg "Reloading $NAME daemon: not implemented, as the daemon"
180 log_warning_msg "cannot re-read the config file (use restart)."
181 ;;
182 *)
183 N=/etc/init.d/openvswitch-ipsec
184 echo "Usage: $N {start|stop|force-stop|restart|force-reload|status}" >&2
185 exit 1
186 ;;
187 esac
188
189 exit 0